//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%382C7C88EA88.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%382C7C88EA88.cm

//## begin module%382C7C88EA88.cp preserve=no
//## end module%382C7C88EA88.cp

//## Module: ParamData%382C7C88EA88; Package body
//## Subsystem: XSModel::Parameter%367691A8CEA0
//	/local/data/verisB/dorman/Xspec/src/XSModel/Parameter
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Parameter/ParamData.cxx

//## begin module%382C7C88EA88.additionalIncludes preserve=no
//## end module%382C7C88EA88.additionalIncludes

//## begin module%382C7C88EA88.includes preserve=yes
//## end module%382C7C88EA88.includes

// XSutility
#include <XSUtil/Utils/XSutility.h>
// ParamData
#include <XSModel/Parameter/ParamData.h>
//## begin module%382C7C88EA88.declarations preserve=no
//## end module%382C7C88EA88.declarations

//## begin module%382C7C88EA88.additionalDeclarations preserve=yes
//## end module%382C7C88EA88.additionalDeclarations


// Class ParamData 

ParamData::ParamData(const ParamData &right)
  //## begin ParamData::ParamData%3628CFD700D2_copy.hasinit preserve=yes
      : m_value(right.m_value),
        m_delta(right.m_delta),
        m_max(right.m_max),
        m_min(right.m_min),
        m_top(right.m_top),
        m_bot(right.m_bot)
  //## end ParamData::ParamData%3628CFD700D2_copy.hasinit
  //## begin ParamData::ParamData%3628CFD700D2_copy.initialization preserve=yes
  //## end ParamData::ParamData%3628CFD700D2_copy.initialization
{
  //## begin ParamData::ParamData%3628CFD700D2_copy.body preserve=yes
  //## end ParamData::ParamData%3628CFD700D2_copy.body
}

ParamData::ParamData (Real value, Real delta, Real max, Real min, Real top, Real bot)
  //## begin ParamData::ParamData%382C86431718.hasinit preserve=yes
      : m_value(value),
        m_delta(delta),
        m_max(max),
        m_min(min),
        m_top(top),
        m_bot(bot)
  //## end ParamData::ParamData%382C86431718.hasinit
  //## begin ParamData::ParamData%382C86431718.initialization preserve=yes
  //## end ParamData::ParamData%382C86431718.initialization
{
  //## begin ParamData::ParamData%382C86431718.body preserve=yes
  //## end ParamData::ParamData%382C86431718.body
}


ParamData::~ParamData()
{
  //## begin ParamData::~ParamData%3628CFD700D2_dest.body preserve=yes
  //## end ParamData::~ParamData%3628CFD700D2_dest.body
}


ParamData & ParamData::operator=(const ParamData &right)
{
  //## begin ParamData::operator=%3628CFD700D2_assign.body preserve=yes
    ParamData __temp(right);
    swap(__temp);
    return *this;
  //## end ParamData::operator=%3628CFD700D2_assign.body
}



//## Other Operations (implementation)
void ParamData::init (Real values, Real delta, Real max, Real min, Real top, Real bottom)
{
  //## begin ParamData::init%38E3C7659AC8.body preserve=yes
   m_value = values;
   m_delta = delta;
   m_max = max;
   m_min = min;
   m_top = top;
   m_bot = bottom;
  //## end ParamData::init%38E3C7659AC8.body
}

void ParamData::swap (ParamData& right) throw ()
{
  //## begin ParamData::swap%3A8D68D80112.body preserve=yes
      XSutility::swap(m_max,right.m_max);
      XSutility::swap(m_min,right.m_min);
      XSutility::swap(m_value,right.m_value);
      XSutility::swap(m_delta,right.m_delta);
      XSutility::swap(m_top,right.m_top);
      XSutility::swap(m_bot,right.m_bot);
  //## end ParamData::swap%3A8D68D80112.body
}

// Additional Declarations
  //## begin ParamData%3628CFD700D2.declarations preserve=yes
  //## end ParamData%3628CFD700D2.declarations

//## begin module%382C7C88EA88.epilog preserve=yes
//## end module%382C7C88EA88.epilog
